Transition to disttag — различия между версиями

Материал из ALT Linux Wiki
Перейти к: навигация, поиск
м (Если ставится в систему с пакетом N = E:V-R:D: rpm -Uhv -- лишний вывод)
м (Проверка Conflicts: N > E:V-R (без disttag): заполнил все случаи в этой части)
Строка 44: Строка 44:
 
В качестве пакета с <code>N = E:V-R:D</code> будет {{pkg|libwiretap}} с <code>libwiretap = 2.6.6-alt1:sisyphus+219299.100.2.1</code>.
 
В качестве пакета с <code>N = E:V-R:D</code> будет {{pkg|libwiretap}} с <code>libwiretap = 2.6.6-alt1:sisyphus+219299.100.2.1</code>.
  
=====Если ставится одновременно с пакетом N = E:V-R:D=====
+
Это подпакеты одного исходного пакета, поэтому есть возможность в <code>Conflicts</code> вставить disttag той же самой сборки.
 +
 
 +
====={{fail}}Если ставится одновременно с пакетом N = E:V-R:D=====
  
 
  # rpm -U /home/user/MNT/ALT/repo/sisyphus/date/2019/01/18/x86_64/RPMS.classic/{libwiretap,wireshark-base}-2.6.6-alt1.x86_64.rpm --test
 
  # rpm -U /home/user/MNT/ALT/repo/sisyphus/date/2019/01/18/x86_64/RPMS.classic/{libwiretap,wireshark-base}-2.6.6-alt1.x86_64.rpm --test
Строка 52: Строка 54:
 
Эффект объясним тем, что <code>2.6.6-alt1:sisyphus+219299.100.2.1</code> лексикографически больше <code>2.6.6-alt1</code> (для "старого" rpm ("rpm-install"), который не отделяет disttag).
 
Эффект объясним тем, что <code>2.6.6-alt1:sisyphus+219299.100.2.1</code> лексикографически больше <code>2.6.6-alt1</code> (для "старого" rpm ("rpm-install"), который не отделяет disttag).
  
=====Если ставится одновременно с пакетом N = E:V-R=====
+
====={{ok}}Если ставится одновременно с пакетом N = E:V-R=====
 +
 
 +
Это совпадает со старой ситуацией, когда disttag-а нет ни в <code>Provides</code>, ни в <code>Conflicts</code>; поэтому не буду проверять.
  
=====Если ставится в систему с пакетом N = E:V-R:D=====
+
====={{fail}}Если ставится в систему с пакетом N = E:V-R:D=====
  
 
  # rpm -U /home/user/MNT/ALT/repo/sisyphus/date/2019/01/18/x86_64/RPMS.classic/libwiretap-2.6.6-alt1.x86_64.rpm --nodeps
 
  # rpm -U /home/user/MNT/ALT/repo/sisyphus/date/2019/01/18/x86_64/RPMS.classic/libwiretap-2.6.6-alt1.x86_64.rpm --nodeps
Строка 68: Строка 72:
 
  #
 
  #
  
=====Если ставится в систему с пакетом N = E:V-R=====
+
====={{ok}}Если ставится в систему с пакетом N = E:V-R=====
 +
 
 +
Это совпадает со старой ситуацией, когда disttag-а нет ни в <code>Provides</code>, ни в <code>Conflicts</code>; поэтому не буду проверять.
  
=====Если уже стоит, а ставится пакет N = E:V-R:D=====
+
====={{fail}}Если уже стоит, а ставится пакет N = E:V-R:D=====
  
 
В качестве примера пакета с конфликтом будет {{pkg|wireshark-base}}.
 
В качестве примера пакета с конфликтом будет {{pkg|wireshark-base}}.
Строка 83: Строка 89:
 
  #
 
  #
  
=====Если уже стоит, а ставится пакет N = E:V-R=====
+
====={{ok}}Если уже стоит, а ставится пакет N = E:V-R=====
 +
 
 +
Это совпадает со старой ситуацией, когда disttag-а нет ни в <code>Provides</code>, ни в <code>Conflicts</code>; поэтому не буду проверять.
  
 
====Проверка Conflicts: N > E:V-R:D====
 
====Проверка Conflicts: N > E:V-R:D====

Версия 06:19, 23 января 2019


В "идентификаторах" пакетов (основных Provides) появился disttag (D: N-E:V-R:D), который различает разные сборки пакета из одних и тех же исходников (E:V-R). Disttag имеет особую семантику при участии в удовлетворении зависимостей и т.п., а также при принятии решения об обновлении (какая сборка пакета будет предпочтительна).

Содержание

Желаемое поведение

Желаемое поведение rpm ("rpm-install") в отношении disttag вот такое:

...

Мы полагаем, что такое поведение уже реализовано в "новом" rpm ("rpm-install"), а именно 4.13.0.1-alt5.

Особенности поведения "нового" и "старого" rpm ("rpm-install") в отношении disttag

Здесь нас особенно волнует поведение "старого" rpm ("rpm-install"), а именно 4.13.0.1-alt4 или старого из p8 и пр., при столкновении с пакетом, где уже используется disttag (был добавлен туда "новым" rpm-build).

Что касается "нового" rpm ("rpm-install"), то он задуман так, что требования N > E:V-R:D и N > E:V-R (без disttag) будут удволетворяться одним и тем же множеством пакетов (потому что disttag-и несравнимы), а значит, будут иметь одинаковый эффект:

  • Requires: N > E:V-R:D и Requires: N > E:V-R (без disttag);
  • Conflicts: N > E:V-R:D и Conflicts: N > E:V-R (без disttag);
  • Obsoletes: N > E:V-R:D и Obsoletes: N > E:V-R (без disttag).

То же самое верно для другого строгого знака: требования N < E:V-R:D и N < E:V-R (без disttag) будут удволетворяться одним и тем же множеством пакетов.

Так что выбор между двумя возможностям (как записать такие Conflicts, Obsoletes; такой Requires бесполезен) может быть сделан на основе более желательного поведения "старого" rpm ("rpm-install") при столкновении с такими пакетами.

Проверка Conflicts старым rpm

Проверка Conflicts: N > E:V-R (без disttag)

В качестве примера пакета с таким Conflicts возьмём wireshark, известный из altbug #35930:

$ curlftpfs -o allow_other,kernel_cache ftp://ftp.altlinux.org/pub/distributions/archive /home/user/MNT/ALT/repo
$ rpm -qp /home/user/MNT/ALT/repo/sisyphus/date/2019/01/18/x86_64/RPMS.classic/wireshark-base-2.6.6-alt1.x86_64.rpm --conflicts
libwiretap < 2.6.6-alt1
libwiretap > 2.6.6-alt1
$ rpm -qp /home/user/MNT/ALT/repo/sisyphus/date/2019/01/18/x86_64/RPMS.classic/libwiretap-2.6.6-alt1.x86_64.rpm --conflicts
$ rpm -qp /home/user/MNT/ALT/repo/sisyphus/date/2019/01/18/x86_64/RPMS.classic/libwiretap-2.6.6-alt1.x86_64.rpm --provides
libwiretap.so.8()(64bit) = set:ld8aYWy1b4sDqBG48DBFCfoLMB7ddqH0djoHz6nkgZxZg0U6Z4hcDibrGMxjeHecL0Im93t540UZhZkWksc6JQSTO5f5MsjHo0otcB67zHX9QF2Aib0Ju7PlbxYsbdSJXxzl9F0s39w1pgg5cHY2sOk4EayatUUDZE6rlcCvCChZdGIJymMi7r6HhL7fFnngAeD3W9u1aZ6XojbFT0s1B70TZma8q98f1K4wqAjqjV3yuVTgZwVQusUpqRSzmGE8AfCSuuYcPgn6ccnLwZJfEUcm30faIAHtdvZ1oARYoa0
libwiretap = 2.6.6-alt1:sisyphus+219299.100.2.1
$ 

В качестве примера пакета с конфликтом будет wireshark-base. В качестве пакета с N = E:V-R:D будет libwiretap с libwiretap = 2.6.6-alt1:sisyphus+219299.100.2.1.

Это подпакеты одного исходного пакета, поэтому есть возможность в Conflicts вставить disttag той же самой сборки.

Test-result-fail.png Если ставится одновременно с пакетом N = E:V-R:D
# rpm -U /home/user/MNT/ALT/repo/sisyphus/date/2019/01/18/x86_64/RPMS.classic/{libwiretap,wireshark-base}-2.6.6-alt1.x86_64.rpm --test
error: Failed dependencies:
	libwiretap > 2.6.6-alt1 conflicts with wireshark-base-2.6.6-alt1.x86_64

Эффект объясним тем, что 2.6.6-alt1:sisyphus+219299.100.2.1 лексикографически больше 2.6.6-alt1 (для "старого" rpm ("rpm-install"), который не отделяет disttag).

Test-result-pass.png Если ставится одновременно с пакетом N = E:V-R

Это совпадает со старой ситуацией, когда disttag-а нет ни в Provides, ни в Conflicts; поэтому не буду проверять.

Test-result-fail.png Если ставится в систему с пакетом N = E:V-R:D
# rpm -U /home/user/MNT/ALT/repo/sisyphus/date/2019/01/18/x86_64/RPMS.classic/libwiretap-2.6.6-alt1.x86_64.rpm --nodeps
# rpm -U /home/user/MNT/ALT/repo/sisyphus/date/2019/01/18/x86_64/RPMS.classic/wireshark-base-2.6.6-alt1.x86_64.rpm --test
error: Failed dependencies:
	libwiretap > 2.6.6-alt1 conflicts with wireshark-base-2.6.6-alt1.x86_64
# rpm -q libwiretap
libwiretap-2.6.6-alt1.x86_64
# rpm -q libwiretap --provides
libwiretap.so.8()(64bit) = 
set:ld8aYWy1b4sDqBG48DBFCfoLMB7ddqH0djoHz6nkgZxZg0U6Z4hcDibrGMxjeHecL0Im93t540UZhZkWksc6JQSTO5f5MsjHo0otcB67zHX9QF2Aib0Ju7PlbxYsbdSJXxzl9F0s39w1pgg5cHY2sOk4EayatUUDZE6rlcCvCChZdGIJymMi7r6HhL7fFnngAeD3W9u1aZ6XojbFT0s1B70TZma8q98f1K4wqAjqjV3yuVTgZwVQusUpqRSzmGE8AfCSuuYcPgn6ccnLwZJfEUcm30faIAHtdvZ1oARYoa0
libwiretap = 2.6.6-alt1:sisyphus+219299.100.2.1
#
Test-result-pass.png Если ставится в систему с пакетом N = E:V-R

Это совпадает со старой ситуацией, когда disttag-а нет ни в Provides, ни в Conflicts; поэтому не буду проверять.

Test-result-fail.png Если уже стоит, а ставится пакет N = E:V-R:D

В качестве примера пакета с конфликтом будет wireshark-base.

# rpm -U /home/user/MNT/ALT/repo/sisyphus/date/2019/01/18/x86_64/RPMS.classic/wireshark-base-2.6.6-alt1.x86_64.rpm --nodeps
# rpm -q wireshark-base --conflicts
libwiretap < 2.6.6-alt1
libwiretap > 2.6.6-alt1
# rpm -U /home/user/MNT/ALT/repo/sisyphus/date/2019/01/18/x86_64/RPMS.classic/libwiretap-2.6.6-alt1.x86_64.rpm --test
error: Failed dependencies:
	libwiretap > 2.6.6-alt1 conflicts with (installed) wireshark-base-2.6.6-alt1.x86_64
#
Test-result-pass.png Если уже стоит, а ставится пакет N = E:V-R

Это совпадает со старой ситуацией, когда disttag-а нет ни в Provides, ни в Conflicts; поэтому не буду проверять.

Проверка Conflicts: N > E:V-R:D

Если ставится одновременно с пакетом N = E:V-R:D
Если ставится одновременно с пакетом N = E:V-R
Если ставится в систему с пакетом N = E:V-R:D
Если ставится в систему с пакетом N = E:V-R
Если уже стоит, а ставится пакет N = E:V-R:D
Если уже стоит, а ставится пакет N = E:V-R

Проверка Conflicts: N < E:V-R (без disttag)

Если ставится одновременно с пакетом N = E:V-R:D
Если ставится одновременно с пакетом N = E:V-R
Если ставится в систему с пакетом N = E:V-R:D
Если ставится в систему с пакетом N = E:V-R
Если уже стоит, а ставится пакет N = E:V-R:D
Если уже стоит, а ставится пакет N = E:V-R

Проверка Conflicts: N < E:V-R:D

Если ставится одновременно с пакетом N = E:V-R:D
Если ставится одновременно с пакетом N = E:V-R
Если ставится в систему с пакетом N = E:V-R:D
Если ставится в систему с пакетом N = E:V-R
Если уже стоит, а ставится пакет N = E:V-R:D
Если уже стоит, а ставится пакет N = E:V-R